/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.adsense.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for AdClient.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the AdSense Management API. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class AdClient extends GenericJson {

  /**
   * Whether this ad client is opted in to ARC.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean arcOptIn;

  /**
   * Unique identifier of this ad client.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Kind of resource this is, in this case adsense#adClient.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * This ad client's product code, which corresponds to the PRODUCT_CODE report dimension.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String productCode;

  /**
   * Whether this ad client supports being reported on.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Boolean supportsReporting;

  /**
   * Whether this ad client is opted in to ARC.
   * The value returned may be {@code null}.
   */
  public Boolean getArcOptIn() {
    return arcOptIn;
  }

  /**
   * Whether this ad client is opted in to ARC.
   * The value set may be {@code null}.
   */
  public AdClient setArcOptIn(Boolean arcOptIn) {
    this.arcOptIn = arcOptIn;
    return this;
  }

  /**
   * Unique identifier of this ad client.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Unique identifier of this ad client.
   * The value set may be {@code null}.
   */
  public AdClient setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Kind of resource this is, in this case adsense#adClient.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Kind of resource this is, in this case adsense#adClient.
   * The value set may be {@code null}.
   */
  public AdClient setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * This ad client's product code, which corresponds to the PRODUCT_CODE report dimension.
   * The value returned may be {@code null}.
   */
  public String getProductCode() {
    return productCode;
  }

  /**
   * This ad client's product code, which corresponds to the PRODUCT_CODE report dimension.
   * The value set may be {@code null}.
   */
  public AdClient setProductCode(String productCode) {
    this.productCode = productCode;
    return this;
  }

  /**
   * Whether this ad client supports being reported on.
   * The value returned may be {@code null}.
   */
  public Boolean getSupportsReporting() {
    return supportsReporting;
  }

  /**
   * Whether this ad client supports being reported on.
   * The value set may be {@code null}.
   */
  public AdClient setSupportsReporting(Boolean supportsReporting) {
    this.supportsReporting = supportsReporting;
    return this;
  }

}
